<?php
class transactionInfo {
  public $errorCode; // int
  public $extendedErrorCode; // string
  public $transactionStatus; // int
  public $timestamp; // long
  public $signature; // string
  public $transactionStatusLabel; // string
  public $paymentGeneralInfo; // transactionPaymentGeneralInfo
  public $cardInfo; // transactionCardInfo
  public $threeDSInfo; // transactionThreeDSInfo
  public $authorizationInfo; // transactionAuthorizationInfo
  public $markInfo; // transactionMarkInfo
  public $warrantyDetailsInfo; // transactionWarrantyDetailsInfo
  public $captureInfo; // transactionCaptureInfo
  public $customerInfo; // transactionCustomerInfo
  public $shippingInfo; // transactionShippingInfo
  public $extraInfo; // transactionExtraInfo
  public $paymentOptionInfo; // transactionPaymentOptionInfo
  public $boletoInfo; // transactionBoletoExtraInfo
}

class transactionPaymentGeneralInfo {
  public $siteId; // string
  public $paymentSource; // string
  public $orderId; // string
  public $orderInfo; // string
  public $orderInfo2; // string
  public $orderInfo3; // string
  public $transmissionDate; // dateTime
  public $transactionId; // string
  public $sequenceNumber; // int
  public $amount; // long
  public $initialAmount; // long
  public $currency; // int
  public $effectiveAmount; // long
  public $effectiveCurrency; // int
  public $presentationDate; // dateTime
  public $type; // int
  public $multiplePayment; // int
  public $effectiveCreationDate; // dateTime
}

class transactionCardInfo {
  public $cardNumber; // string
  public $cardNetwork; // string
  public $cardBrand; // string
  public $cardCountry; // long
  public $cardProductCode; // string
  public $cardBankCode; // string
  public $expiryMonth; // int
  public $expiryYear; // int
  public $contractNumber; // string
}

class transactionThreeDSInfo {
  public $threeDSTransactionCondition; // string
  public $threeDSEnrolled; // string
  public $threeDSStatus; // string
  public $threeDSEci; // string
  public $threeDSXid; // string
  public $threeDSCavvAlgorithm; // string
  public $threeDSCavv; // string
  public $threeDSSignValid; // string
  public $threeDSBrand; // string
}

class transactionAuthorizationInfo {
  public $authMode; // string
  public $authAmount; // long
  public $authCurrency; // int
  public $authDate; // dateTime
  public $authNumber; // string
  public $authResult; // int
  public $authCVV2_CVC2; // string
}

class transactionMarkInfo {
  public $markAmount; // long
  public $markCurrency; // int
  public $markDate; // dateTime
  public $markNb; // string
  public $markResult; // int
  public $markCVV2_CVC2; // string
}

class transactionWarrantyDetailsInfo {
  public $paymentError; // int
  public $warrantyResult; // string
  public $localControl; // localControl
  public $litige; // boolean
}

class localControl {
  public $name; // string
  public $result; // boolean
}

class transactionCaptureInfo {
  public $captureDate; // dateTime
  public $captureNumber; // int
  public $rapprochementStatut; // int
  public $refundAmount; // long
  public $refundCurrency; // int
}

class transactionCustomerInfo {
  public $customerId; // string
  public $customerTitle; // string
  public $customerStatus; // custStatus
  public $customerName; // string
  public $customerPhone; // string
  public $customerEmail; // string
  public $customerAddressNumber; // string
  public $customerAddress; // string
  public $customerDistrict; // string
  public $customerZip; // string
  public $customerCity; // string
  public $customerCountry; // string
  public $language; // string
  public $customerIP; // string
  public $customerCellPhone; // string
  public $extInfo; // extInfo
}

class extInfo {
  public $key; // string
  public $value; // string
}

class transactionShippingInfo {
  public $shippingCity; // string
  public $shippingCountry; // string
  public $shippingDeliveryCompanyName; // string
  public $shippingName; // string
  public $shippingPhone; // string
  public $shippingSpeed; // deliverySpeed
  public $shippingState; // string
  public $shippingStatus; // custStatus
  public $shippingStreetNumber; // string
  public $shippingStreet; // string
  public $shippingStreet2; // string
  public $shippingDistrict; // string
  public $shippingType; // deliveryType
  public $shippingZipCode; // string
}

class transactionExtraInfo {
  public $ctxMode; // string
}

class transactionPaymentOptionInfo {
  public $code; // string
  public $nbOfOccurrence; // int
}

class transactionBoletoExtraInfo {
  public $url; // string
}

class paymentCreationInfo {
  public $paymentGeneralInfo; // createPaymentGeneralInfo
  public $cardInfo; // createCardInfo
  public $threeDsResult; // threeDsResult
  public $subPaymentInfo; // createSubPaymentInfo
  public $customerInfo; // createCustomerInfo
  public $shippingInfo; // createShippingInfo
  public $extraInfo; // createExtraInfo
}

class createPaymentGeneralInfo {
  public $siteId; // string
  public $transmissionDate; // dateTime
  public $transactionId; // string
  public $paymentSource; // string
  public $orderId; // string
  public $orderInfo; // string
  public $orderInfo2; // string
  public $orderInfo3; // string
  public $amount; // long
  public $currency; // int
  public $presentationDate; // dateTime
  public $validationMode; // int
}

class createCardInfo {
  public $cardNumber; // string
  public $cardNetwork; // string
  public $expiryMonth; // int
  public $expiryYear; // int
  public $cvv; // string
  public $cardBirthDay; // dateTime
  public $cardIdent; // string
  public $contractNumber; // string
  public $paymentOptionCode; // string
}

class threeDsResult {
  public $threeDSBrand; // string
  public $threeDSEnrolled; // string
  public $threeDSStatus; // string
  public $threeDSEci; // string
  public $threeDSXid; // string
  public $threeDSCavv; // string
  public $threeDSCavvAlgorithm; // string
}

class createSubPaymentInfo {
  public $subPaymentType; // int
  public $subReference; // string
  public $subPaymentNumber; // int
}

class createCustomerInfo {
  public $customerId; // string
  public $customerTitle; // string
  public $customerStatus; // custStatus
  public $customerName; // string
  public $customerPhone; // string
  public $customerEmail; // string
  public $customerAddressNumber; // string
  public $customerAddress; // string
  public $customerDistrict; // string
  public $customerZip; // string
  public $customerCity; // string
  public $customerState; // string
  public $customerCountry; // string
  public $language; // string
  public $customerIP; // string
  public $customerSendEmail; // boolean
  public $customerCellPhone; // string
  public $customerSourceInfo; // string
  public $extInfo; // extInfo
}

class createShippingInfo {
  public $shippingCity; // string
  public $shippingCountry; // string
  public $shippingDeliveryCompanyName; // string
  public $shippingName; // string
  public $shippingPhone; // string
  public $shippingSpeed; // deliverySpeed
  public $shippingState; // string
  public $shippingStatus; // custStatus
  public $shippingStreetNumber; // string
  public $shippingStreet; // string
  public $shippingStreet2; // string
  public $shippingDistrict; // string
  public $shippingType; // deliveryType
  public $shippingZipCode; // string
}

class createExtraInfo {
  public $ctxMode; // string
  public $browserUserAgent; // string
  public $browserAccept; // string
}

class standardResponse {
  public $timestamp; // long
  public $signature; // string
  public $errorCode; // int
  public $extendedErrorCode; // string
  public $transactionStatus; // int
}

class createPaymentInfo {
  public $paymentGeneralInfo; // createPaymentGeneralInfo
  public $cardInfo; // createCardInfo
  public $subPaymentInfo; // createSubPaymentInfo
  public $customerInfo; // createCustomerInfo
  public $shippingInfo; // createShippingInfo
  public $extraInfo; // createExtraInfo
}

class createWithThreeDSResponse {
  public $errorCode; // int
  public $extendedErrorCode; // string
  public $timestamp; // long
  public $signature; // string
  public $veResPAReqInfo; // veResPAReqInfo
  public $transactionInfo; // transactionInfo
}

class veResPAReqInfo {
  public $errorCode; // string
  public $errorDetail; // string
  public $signature; // string
  public $timestamp; // long
  public $threeDSAcctId; // string
  public $threeDSAcsUrl; // string
  public $threeDSBrand; // string
  public $threeDSEncodedPareq; // string
  public $threeDSEnrolled; // string
  public $threeDSRequestId; // string
}

class abstractThreeDSecureResponse {
  public $errorCode; // string
  public $errorDetail; // string
  public $signature; // string
  public $timestamp; // long
}

class custStatus {
  const _PRIVATE = 'PRIVATE';
  const COMPANY = 'COMPANY';
}

class deliverySpeed {
  const STANDARD = 'STANDARD';
  const EXPRESS = 'EXPRESS';
}

class deliveryType {
  const RECLAIM_IN_SHOP = 'RECLAIM_IN_SHOP';
  const RELAY_POINT = 'RELAY_POINT';
  const RECLAIM_IN_STATION = 'RECLAIM_IN_STATION';
  const PACKAGE_DELIVERY_COMPANY = 'PACKAGE_DELIVERY_COMPANY';
  const ETICKET = 'ETICKET';
}


/**
 * StandardWS class
 * 
 *  
 * 
 * @author    {author}
 * @copyright {copyright}
 * @package   {package}
 */
class StandardWS extends SoapClient {

  private static $classmap = array(
                                    'transactionInfo' => 'transactionInfo',
                                    'transactionPaymentGeneralInfo' => 'transactionPaymentGeneralInfo',
                                    'transactionCardInfo' => 'transactionCardInfo',
                                    'transactionThreeDSInfo' => 'transactionThreeDSInfo',
                                    'transactionAuthorizationInfo' => 'transactionAuthorizationInfo',
                                    'transactionMarkInfo' => 'transactionMarkInfo',
                                    'transactionWarrantyDetailsInfo' => 'transactionWarrantyDetailsInfo',
                                    'localControl' => 'localControl',
                                    'transactionCaptureInfo' => 'transactionCaptureInfo',
                                    'transactionCustomerInfo' => 'transactionCustomerInfo',
                                    'extInfo' => 'extInfo',
                                    'transactionShippingInfo' => 'transactionShippingInfo',
                                    'transactionExtraInfo' => 'transactionExtraInfo',
                                    'transactionPaymentOptionInfo' => 'transactionPaymentOptionInfo',
                                    'transactionBoletoExtraInfo' => 'transactionBoletoExtraInfo',
                                    'paymentCreationInfo' => 'paymentCreationInfo',
                                    'createPaymentGeneralInfo' => 'createPaymentGeneralInfo',
                                    'createCardInfo' => 'createCardInfo',
                                    'threeDsResult' => 'threeDsResult',
                                    'createSubPaymentInfo' => 'createSubPaymentInfo',
                                    'createCustomerInfo' => 'createCustomerInfo',
                                    'createShippingInfo' => 'createShippingInfo',
                                    'createExtraInfo' => 'createExtraInfo',
                                    'standardResponse' => 'standardResponse',
                                    'createPaymentInfo' => 'createPaymentInfo',
                                    'createWithThreeDSResponse' => 'createWithThreeDSResponse',
                                    'veResPAReqInfo' => 'veResPAReqInfo',
                                    'abstractThreeDSecureResponse' => 'abstractThreeDSecureResponse',
                                    'custStatus' => 'custStatus',
                                    'deliverySpeed' => 'deliverySpeed',
                                    'deliveryType' => 'deliveryType',
                                   );

  public function StandardWS($wsdl = "https://secure.payzen.eu/vads-ws/v4.3?wsdl", $options = array('trace'=>1,'encoding' => 'UTF-8')) {
    foreach(self::$classmap as $key => $value) {
      if(!isset($options['classmap'][$key])) {
        $options['classmap'][$key] = $value;
      }
    }
    parent::__construct($wsdl, $options);
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $comment
   * @param string $key
   * @return standardResponse
   */
  public function cancel($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).		
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," CANCEL [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);	
	
	return $this->__soapCall('cancel', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param paymentCreationInfo $createInfo
   * @param string $key
   * @return transactionInfo
   */
  public function create(paymentCreationInfo $createInfo, $key) {
    /**
	Construction de la chaine utilise pour gnrer le champ $wsSignature:
	Les champs sont pris dans l'ordre suivant:
	paymentGeneralInfo, cardInfo, threeDsResult, subPaymentInfo, customerInfo, shippingInfo, extraInfo
	*/
		$hashSign='';		
		$hashSign=
		/**
		paymentCreationInfo.paymentGeneralInfo
		*/
		getSignatureValue($createInfo->paymentGeneralInfo->siteId).
		getSignatureValue($createInfo->paymentGeneralInfo->transactionId).
		getSignatureValue($createInfo->paymentGeneralInfo->paymentSource).
		getSignatureValue($createInfo->paymentGeneralInfo->orderId).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo2).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo3).
		getSignatureValue($createInfo->paymentGeneralInfo->amount).
		getSignatureValue($createInfo->paymentGeneralInfo->currency).
		getSignatureValue($createInfo->paymentGeneralInfo->validationMode).
		/**
		paymentCreationInfo.cardInfo
		*/
		getSignatureValue($createInfo->cardInfo->cardNumber).
		getSignatureValue($createInfo->cardInfo->cardNetwork).
		getSignatureValue($createInfo->cardInfo->expiryMonth).
		getSignatureValue($createInfo->cardInfo->expiryYear).
		getSignatureValue($createInfo->cardInfo->cvv).
		getSignatureValue($createInfo->cardInfo->cardIdent).	
		getSignatureValue($createInfo->cardInfo->cardBirthDay).
		getSignatureValue($createInfo->cardInfo->contractNumber).			
		getSignatureValue($createInfo->cardInfo->paymentOptionCode);
		/**
		paymentCreationInfo.threeDsResult
		*/		
		if (!is_null($createInfo->threeDsResult)){		
		$hashSign .=
		getSignatureValue($createInfo->threeDsResult->threeDSBrand).
		getSignatureValue($createInfo->threeDsResult->threeDSEnrolled).
		getSignatureValue($createInfo->threeDsResult->threeDSStatus).
		getSignatureValue($createInfo->threeDsResult->threeDSEci).
		getSignatureValue($createInfo->threeDsResult->threeDSXid).
		getSignatureValue($createInfo->threeDsResult->threeDSCavv).
		getSignatureValue($createInfo->threeDsResult->threeDSCavvAlgorithm);
		}
		else{
		$hashSign .= "+";
		}
		/**
		paymentCreationInfo.subPaymentInfo
		*/
		if (!is_null($createInfo->subPaymentInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->subPaymentInfo->subPaymentType).
		getSignatureValue($createInfo->subPaymentInfo->subReference).
		getSignatureValue($createInfo->subPaymentInfo->subPaymentNumber);
		}
		else{
		$hashSign .= "+";
		}
		/**
		paymentCreationInfo.customerInfo
		*/
		if (!is_null($createInfo->customerInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->customerInfo->customerId).
		getSignatureValue($createInfo->customerInfo->customerTitle).
		getSignatureValue($createInfo->customerInfo->customerStatus).
		getSignatureValue($createInfo->customerInfo->customerName).
		getSignatureValue($createInfo->customerInfo->customerPhone).
		getSignatureValue($createInfo->customerInfo->customerEmail).
		getSignatureValue($createInfo->customerInfo->customerAddressNumber). 
		getSignatureValue($createInfo->customerInfo->customerAddress).
		getSignatureValue($createInfo->customerInfo->customerDistrict).
		getSignatureValue($createInfo->customerInfo->customerZip).
		getSignatureValue($createInfo->customerInfo->customerCity).
		getSignatureValue($createInfo->customerInfo->customerCountry).
		getSignatureValue($createInfo->customerInfo->language).
		getSignatureValue($createInfo->customerInfo->customerIP).
		getSignatureValue($createInfo->customerInfo->customerSendEmail).
		getSignatureValue($createInfo->customerInfo->customerCellPhone).
		getSignatureValue($createInfo->customerInfo->extInfo);
		}
		else{
		$hashSign .= "+";
		}
		 /**
		paymentCreationInfo.shippingInfo
		*/  
		if (!is_null($createInfo->shippingInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->shippingInfo->shippingCity).
		getSignatureValue($createInfo->shippingInfo->shippingCountry).
		getSignatureValue($createInfo->shippingInfo->shippingDeliveryCompanyName).
		getSignatureValue($createInfo->shippingInfo->shippingName).
		getSignatureValue($createInfo->shippingInfo->shippingPhone).	
		getSignatureValue($createInfo->shippingInfo->shippingSpeed).
		getSignatureValue($createInfo->shippingInfo->shippingState).
		getSignatureValue($createInfo->shippingInfo->shippingStatus).
		getSignatureValue($createInfo->shippingInfo->shippingStreetNumber).
		getSignatureValue($createInfo->shippingInfo->shippingStreet).
		getSignatureValue($createInfo->shippingInfo->shippingStreet2).
		getSignatureValue($createInfo->shippingInfo->shippingDistrict).
		getSignatureValue($createInfo->shippingInfo->shippingType).
		getSignatureValue($createInfo->shippingInfo->shippingZipCode);
		}
		else{
		$hashSign .= "+";
		}
		/**
		paymentCreationInfo.extraInfo
		*/		
		$hashSign .=
		getSignatureValue($createInfo->extraInfo->ctxMode).
		getSignatureValue($createInfo->extraInfo->browserUserAgent).
		getSignatureValue($createInfo->extraInfo->browserAccept);		
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," CREATE [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$createInfo->paymentGeneralInfo->transmissionDate = $createInfo->paymentGeneralInfo->transmissionDate->format(dateTime::W3C);
		$createInfo->paymentGeneralInfo->presentationDate = $createInfo->paymentGeneralInfo->presentationDate->format(dateTime::W3C);
		
		/**
		Suppression des champs valoriss  null
		*/
		foreach ($createInfo as $key=>$value){
			if ($value == null){
			unset ($createInfo->$key);}
		}
	
	
	
	
	
	return $this->__soapCall('create', array($createInfo, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param createPaymentInfo $createInfo
   * @param string $key
   * @return createWithThreeDSResponse
   */
  public function createWithThreeDS(createPaymentInfo $createInfo, $key) {
    
	/**
	Construction de la chaine utilise pour gnrer le champ $wsSignature:
	Les champs sont pris dans l'ordre suivant:
	createPaymentInfo.paymentGeneralInfo, createPaymentInfo.cardInfo, createPaymentInfo.subPaymentInfo, createPaymentInfo.customerInfo, createPaymentInfo.shippingInfo, createPaymentInfo.extraInfo
	*/
		$hashSign='';		
		$hashSign=
		/**
		createPaymentInfo.paymentGeneralInfo
		*/
		getSignatureValue($createInfo->paymentGeneralInfo->siteId).
		getSignatureValue($createInfo->paymentGeneralInfo->transactionId).
		getSignatureValue($createInfo->paymentGeneralInfo->paymentSource).
		getSignatureValue($createInfo->paymentGeneralInfo->orderId).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo2).
		getSignatureValue($createInfo->paymentGeneralInfo->orderInfo3).
		getSignatureValue($createInfo->paymentGeneralInfo->amount).
		getSignatureValue($createInfo->paymentGeneralInfo->currency).
		getSignatureValue($createInfo->paymentGeneralInfo->validationMode).
		/**
		createPaymentInfo.cardInfo
		*/
		getSignatureValue($createInfo->cardInfo->cardNumber).
		getSignatureValue($createInfo->cardInfo->cardNetwork).
		getSignatureValue($createInfo->cardInfo->expiryMonth).
		getSignatureValue($createInfo->cardInfo->expiryYear).
		getSignatureValue($createInfo->cardInfo->cvv).
		getSignatureValue($createInfo->cardInfo->cardBirthDay).
		getSignatureValue($createInfo->cardInfo->cardIdent).
		getSignatureValue($createInfo->cardInfo->contractNumber).	
		getSignatureValue($createInfo->cardInfo->paymentOptionCode);
		/**
		paymentCreationInfo.subPaymentInfo
		*/
		if (!is_null($createInfo->subPaymentInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->subPaymentInfo->subPaymentType).
		getSignatureValue($createInfo->subPaymentInfo->subReference).
		getSignatureValue($createInfo->subPaymentInfo->subPaymentNumber);
		}
		else{
		$hashSign .= "+";
		}
		/**
		paymentCreationInfo.customerInfo
		*/
		if (!is_null($createInfo->customerInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->customerInfo->customerId).
		getSignatureValue($createInfo->customerInfo->customerTitle).
		getSignatureValue($createInfo->customerInfo->customerStatus).
		getSignatureValue($createInfo->customerInfo->customerName).
		getSignatureValue($createInfo->customerInfo->customerPhone).
		getSignatureValue($createInfo->customerInfo->customerEmail).
		getSignatureValue($createInfo->customerInfo->customerAddressNumber). 
		getSignatureValue($createInfo->customerInfo->customerAddress).
		getSignatureValue($createInfo->customerInfo->customerDistrict).
		getSignatureValue($createInfo->customerInfo->customerZip).
		getSignatureValue($createInfo->customerInfo->customerCity).
		getSignatureValue($createInfo->customerInfo->customerCountry).
		getSignatureValue($createInfo->customerInfo->language).
		getSignatureValue($createInfo->customerInfo->customerIP).
		getSignatureValue($createInfo->customerInfo->customerSendEmail).
		getSignatureValue($createInfo->customerInfo->customerCellPhone).
		getSignatureValue($createInfo->customerInfo->extInfo);
		}
		else{
		$hashSign .= "+";
		}
		 /**
		paymentCreationInfo.shippingInfo
		*/  
		if (!is_null($createInfo->shippingInfo)){		
		$hashSign .=
		getSignatureValue($createInfo->shippingInfo->shippingCity).
		getSignatureValue($createInfo->shippingInfo->shippingCountry).
		getSignatureValue($createInfo->shippingInfo->shippingDeliveryCompanyName).
		getSignatureValue($createInfo->shippingInfo->shippingName).
		getSignatureValue($createInfo->shippingInfo->shippingPhone).	
		getSignatureValue($createInfo->shippingInfo->shippingSpeed).
		getSignatureValue($createInfo->shippingInfo->shippingState).
		getSignatureValue($createInfo->shippingInfo->shippingStatus).
		getSignatureValue($createInfo->shippingInfo->shippingStreetNumber).
		getSignatureValue($createInfo->shippingInfo->shippingStreet).
		getSignatureValue($createInfo->shippingInfo->shippingStreet2).
		getSignatureValue($createInfo->shippingInfo->shippingDistrict).
		getSignatureValue($createInfo->shippingInfo->shippingType).
		getSignatureValue($createInfo->shippingInfo->shippingZipCode);
		}
		else{
		$hashSign .= "+";
		}
		/**
		paymentCreationInfo.extraInfo
		*/		
		$hashSign .=
		getSignatureValue($createInfo->extraInfo->ctxMode).
		getSignatureValue($createInfo->extraInfo->browserUserAgent).
		getSignatureValue($createInfo->extraInfo->browserAccept);	
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," CREATE3DS [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$createInfo->paymentGeneralInfo->transmissionDate = $createInfo->paymentGeneralInfo->transmissionDate->format(dateTime::W3C);
		$createInfo->paymentGeneralInfo->presentationDate = $createInfo->paymentGeneralInfo->presentationDate->format(dateTime::W3C);
		
		/**
		Suppression des champs valoriss  null
		*/
		foreach ($createInfo as $key=>$value){
			if ($value == null){
			unset ($createInfo->$key);}
		}
	
	
	
	return $this->__soapCall('createWithThreeDS', array($createInfo, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $orderId
   * @param string $orderInfo
   * @param string $orderInfo2
   * @param string $orderInfo3
   * @param long $amount
   * @param int $currency
   * @param string $newTransactionId
   * @param dateTime $presentationDate
   * @param int $validationMode
   * @param string $comment
   * @param string $key
   * @return transactionInfo
   */
  public function duplicate($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $orderId, $orderInfo, $orderInfo2, $orderInfo3, $amount, $currency, $newTransactionId, $presentationDate, $validationMode, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).
		getSignatureValue($orderId).
		getSignatureValue($orderInfo).
		getSignatureValue($orderInfo2).
		getSignatureValue($orderInfo3).
		getSignatureValue($amount).
		getSignatureValue($currency).
		getSignatureValue($newTransactionId).		
		getSignatureValue($validationMode).
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," DUPLICATE [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
		$presentationDate = $presentationDate->format(dateTime::W3C);	
	
	
	return $this->__soapCall('duplicate', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $orderId, $orderInfo, $orderInfo2, $orderInfo3, $amount, $currency, $newTransactionId, $presentationDate, $validationMode, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $threeDSrequestId
   * @param string $pares
   * @param string $key
   * @return transactionInfo
   */
  public function finalizeWithThreeDS($threeDSrequestId, $pares, $key) {
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';
		$hashSign=
			getSignatureValue($threeDSrequestId).
			getSignatureValue($pares);
		
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," FINALIZE [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
	
	
	return $this->__soapCall('finalizeWithThreeDS', array($threeDSrequestId, $pares, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $authNumber
   * @param dateTime $authDate
   * @param string $comment
   * @param string $key
   * @return standardResponse
   */
  public function force($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $authNumber, $authDate, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).
		getSignatureValue($authNumber).		
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," FORCE [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
		$authDate = $authDate->format(dateTime::W3C);
	
	
	
	
	
	return $this->__soapCall('force', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $authNumber, $authDate, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $key
   * @return transactionInfo
   */
  public function getInfo($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $key) {
		
		
	
		
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," GETINFO [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
	
		$request= $siteId.", ".$transmissionDate.", ". $transactionId.", ". $sequenceNumber.", ". $ctxMode.", ". $key;
		trace("LOG"," GETINFO [Paramtres de la requte]", $request);
	
	return $this->__soapCall('getInfo', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param long $amount
   * @param int $currency
   * @param dateTime $presentationDate
   * @param boolean $validate
   * @param string $comment
   * @param string $key
   * @return transactionInfo
   */
  public function modify($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $amount, $currency, $presentationDate, $validate, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).				
		getSignatureValue($amount).
		getSignatureValue($currency).				
		getSignatureValue($validate).
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," MODIFY [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
		$presentationDate = $presentationDate->format(dateTime::W3C);	
	
	
	return $this->__soapCall('modify', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $amount, $currency, $presentationDate, $validate, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $newTransactionId
   * @param long $amount
   * @param int $currency
   * @param dateTime $presentationDate
   * @param int $validationMode
   * @param string $comment
   * @param string $key
   * @return transactionInfo
   */
  public function refund($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $newTransactionId, $amount, $currency, $presentationDate, $validationMode, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).
		getSignatureValue($newTransactionId).		
		getSignatureValue($amount).
		getSignatureValue($currency).				
		getSignatureValue($validationMode).
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," REFUND [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
		$presentationDate = $presentationDate->format(dateTime::W3C);	
	
	return $this->__soapCall('refund', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $newTransactionId, $amount, $currency, $captureDate, $validationMode, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param string $siteId
   * @param dateTime $transmissionDate
   * @param string $transactionId
   * @param int $sequenceNumber
   * @param string $ctxMode
   * @param string $comment
   * @param string $key
   * @return standardResponse
   */
  public function validate($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $comment, $key) {
    
		/**
		Construction de la chaine utilise pour gnrer le champ $wsSignature:
		Les champs sont pris dans l'ordre suivant:	
		*/
		$hashSign='';		
		$hashSign=
		getSignatureValue($siteId).
		getSignatureValue($transactionId).
		getSignatureValue($sequenceNumber).
		getSignatureValue($ctxMode).
		getSignatureValue($comment);
		
		/**
		Ajout du Certificat en fin de chaine	
		*/
		$hashSign .= $key;	
		
		/**
		Optionnel: Ajout des paramtres calculs dans un fichier de log
		*/
		trace("LOG"," VALIDATE [Paramtres  signer]", $hashSign); 	
		/**
		Cryptage de la chaine suivant SHA1
		*/
		$wsSignature=sha1($hashSign);
		
		/**
		Passage des champs DateTime au format W3C
		*/
		$transmissionDate = $transmissionDate->format(dateTime::W3C);
	
	
	return $this->__soapCall('validate', array($siteId, $transmissionDate, $transactionId, $sequenceNumber, $ctxMode, $comment, $wsSignature),       array(
            'uri' => 'http://v4.ws.vads.lyra.com/',
            'soapaction' => ''
           )
      );
  }

}

?>
